/*
    ICRYPT+ / [x]chat module
			-- DaP <profeta@freemail.c3.hu>

    " probald meg jobban csinalni a dolgod ameddig hagylak,
      a vegen vissza majd ugyis a foldnek adlak... "
*/

/*
    $Log: XCicrypt+.c,v $
    Revision 1.1  2000/04/16 16:25:36  dap
    *** empty log message ***


    ---
    $Id: XCicrypt+.c,v 1.1 2000/04/16 16:25:36 dap Exp $
*/

/*
    TODO:
	- fix /me
	- fix title change
	- follow nick changes(?)
	- backport to psybnc :)
*/

#include "xchat.h"
#include "plugin.h"
#include "fe.h"		/* fe_ */
#include "icrypt+.h"	/* cp_chk_ */
#include <stdio.h>	/* (s)printf */
#include <stdlib.h>	/* atoi */
#include <string.h>	/* strchr */

#define	MODNAME	"ICRYPT+"
#define	MODDESC	"ICRYPT+ [x]chat port @ DaP <profeta@freemail.c3.hu>"

#define	KEYFILE	".crypt+.keys"
/* maybe buffer overflow... */
#define	MAXTEXT		1024
/* i hope will never be shorter... */
#define	PRIVMSG_IP_LEN	128

/*
    notes...
	channel_msg()
	    outbuf valtoztatasat miert szurja ki a handle_command???
*/

/* extern globals */
// extern GSList *sigroots[NUM_XP];

/* prototypes */
extern struct module *module_find (char *name);
extern void PrintText (struct session *sess, unsigned char *text);
extern int hook_signal (struct xp_signal *sig);
extern void unhook_signal (struct xp_signal *sig);
extern void module_add_cmds (struct module_cmd_set *cmds);
extern int tcp_send (struct server *serv, char *buf);
extern struct session *find_session_from_channel (char *chan, struct server *serv);
extern void check_special_chars (char *cmd); /* check for %X */

/* hooks */
struct xp_signal sig[3];

/* commands */
int cmd_encrypt (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
int cmd_listencrypt (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
int cmd_delencrypt (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
int cmd_cpd (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
int cmd_hreq (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
struct module_cmd_set cp_cmd_set;
struct commands cp_cmds[] = {
    {"ENCRYPT", cmd_encrypt, 0, 0, "/ENCRYPT <channel> <key>"},
    {"LISTENCRYPT", cmd_listencrypt, 0, 0, "/LISTENCRYPT"},
    {"DELENCRYPT", cmd_delencrypt, 0, 0, "/DELENCRYPT <#>"},
    {"CPD", cmd_cpd, 0, 0, "/CPD <#>"},
    {"HREQ", cmd_hreq, 0, 0, "/HREQ <nick>"},
    {0, 0, 0, 0, 0}
};

/* globals */
struct server *g_serv = NULL;	/* xc_cp_noticeuser() xc_cp_send() */
char last_chanmsg[256];
char debug = 0;


/* CRYPT+ API */
void xc_cp_noticeuser(char *from, char *msg)
{
    char buf[512];
    struct session *sess;


    if (! (sess = find_session_from_channel(from, g_serv)))
	return;

    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O %%C4ICR+%%O %%U>%%U %s %%U<%%U\n",
	    msg);
    check_special_chars(buf);
    PrintText(sess, buf);
}


void xc_cp_send(char *to, char *msg)
{
    char buf[2048];


    if (debug > 1) {
	snprintf(buf, sizeof(buf) - 2, "PRIVMSG %s :(%d)[%s]\n", to, strlen(msg), msg);
	PrintText(g_serv->front_session, buf);
    }

    snprintf(buf, sizeof(buf), "PRIVMSG %s :%s\n", to, msg);
    tcp_send(g_serv, buf);
}


/* HOOKS */
/*
    input:
        text => serv->linebuf[2048]
    output:
        text => inbuf[1024] (only for FE_TEXT)
*/
int (*chanmsg_next)(void *, void *, void *, void *, void *, char);
int chanmsg(struct server *serv, char *chan, char *from, char *text, void *a, char fromme)
{
    struct session *sess;
    char buf[512];


    g_serv = serv;
    if (fromme) {
	/* te_uchanmsg_ate doesn't get (chan) */
	strncpy(last_chanmsg, chan, sizeof(last_chanmsg));

	if (*chan != '#') {
	    /* outgoin' private */
	    if (cp_isencrypted(chan))
		snprintf(buf, sizeof(buf), "%s (encrypted)", chan);
	    else
		snprintf(buf, sizeof(buf), "%s (NOT encrypted)", chan);
	    if ((sess = find_session_from_channel(chan, serv)))
		fe_set_topic(sess, buf);
	}

	if (debug > 1) {
	    snprintf(buf, sizeof(buf) - 2, "PRIVMSG to: %s from: %s, t: (%d)[%s]\n",
		    chan, from, strlen(text), text);
	    PrintText(serv->front_session, buf);
	}

	/*
	    snprintf(buf, sizeof(buf) - 2, "<%s> %s", serv->nick, text_orig);
	    PrintText(serv->front_session, buf);
	    return(1);	// ugly HACK - don't allow textevent...
	*/
    } else {
	/* chan => in/out query:OK channel:OK */
	/* mynick needed to generation of sign, sender nick needed for sign check */
	cp_chk_crypt(serv->nick, chan, from, text, MAXTEXT, fromme);

	if (*chan == '#') {
	    if (debug > 1) {
		snprintf(buf, sizeof(buf) - 2, "CHANMSG fromchan: %s fromnick: %s, t: (%d) %s\n",
			chan, from, strlen(text), text);
		PrintText(serv->front_session, buf);
	    }
	} else {
	    if (debug > 1) {
		snprintf(buf, sizeof(buf) - 2, "PRIVMSG fromchan: %s fromnick: %s, t: (%d) %s\n",
			chan, from, strlen(text), text);
		PrintText(serv->front_session, buf);
	    }

	    if (cp_chk_HANDSHAKE_MSG(from, text))
		return(1);	/* don't allow textevent... (topic?) */
	}
    }
    g_serv = NULL;


    /* it's equal to return() in version 1.4 */
    /* XP_CALLNEXT(chanmsg_next, serv, chan, from, text, a, c); */
    return(0);
}


int (*te_uchanmsg_ate_next)(void *, void *, void *, void *, void *, char);
int te_uchanmsg_ate(struct session *sess, char *real_outbuf, char *text, char *a, void *b, char c)
{
    char buf[512];


    if (debug > 1) {
	snprintf(buf, sizeof(buf) - 2, "cp_chk_crypt(%s, %s, %s)\n",
		real_outbuf, last_chanmsg, text);
	PrintText(sess, buf);
    }

    cp_chk_crypt(real_outbuf, last_chanmsg, last_chanmsg, text, MAXTEXT, TRUE);


    /* never mind */
    return(0);
}


int (*privmsg_next)(void *, void *, void *, void *, void *, char);
int privmsg(struct server *serv, char *from, char *ip, char *text, void *a, char b)
{
    char buf[512];


    /* set topic */
    if (cp_isencrypted(from)) {
	strncpy(buf, ip, sizeof(buf));
	snprintf(ip, PRIVMSG_IP_LEN, "%s (encrypted)", buf);
    } else {
	strncpy(buf, ip, sizeof(buf));
	snprintf(ip, PRIVMSG_IP_LEN, "%s (NOT encrypted)", buf);
    }


    /* never mind */
    return(0);
}


/* COMMANDS */
int cmd_encrypt (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
    char buf[512];
    char channel[256], key[56];


    if (*word_eol[2] == 0 || *word_eol[3] == 0 || *word_eol[4] != 0) {
	snprintf(buf, sizeof(buf) - 2, "/encrypt <channel> <key>\n");
	PrintText(sess, buf);
	return(0);
    }

    memset(channel, 0, sizeof(channel));
    strncpy(channel, word_eol[2], strchr(word_eol[2], ' ') - word_eol[2]);
    strncpy(key, word_eol[3], sizeof(key));

    ucase(channel);
    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O Encryption added to channel: %s (key: %s)\n",
	    channel, key);
    check_special_chars(buf);
    PrintText(sess, buf);

    // get_xdir()
    user(usern)->encrypt = writelist(channel, key, KEYFILE, user(usern)->encrypt);
    // snprintf(buf, sizeof(buf), "%s:%s", channel, key);
    // user(usern)->encrypt = addstring(buf, user(usern)->encrypt);

    return(0);
}


int cmd_listencrypt (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
    char buf[512];
    char *pt;
    int i;


    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O List of encrypted channels\n");
    check_special_chars(buf);
    PrintText(sess, buf);

    i = 0;
    while ((pt = getstring(i, user(usern)->encrypt))) {
	snprintf(buf, sizeof(buf) - 2, "    %d: %s\n", i, pt);
	PrintText(sess, buf);
	i++;
    }

    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O End of list\n");
    check_special_chars(buf);
    PrintText(sess, buf);

    return(0);
}


int cmd_delencrypt (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
    char buf[512];
    int i;


    if (*word_eol[2] == 0 || *word_eol[3] != 0) {
	snprintf(buf, sizeof(buf) - 2, "/delencrypt <#>\n");
	PrintText(sess, buf);
	return(0);
    }

    i = atoi(word_eol[2]);
    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O Remove encryption from channel: %d (%s)\n",
	    i, word_eol[2]);
    check_special_chars(buf);
    PrintText(sess, buf);

    user(usern)->encrypt = eraselist(i, KEYFILE, user(usern)->encrypt);
    // user(usern)->encrypt = removestring(i, user(usern)->encrypt);

    return(0);
}


int cmd_cpd (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
    char buf[512];
    int i;


    if (*word_eol[2] == 0 || *word_eol[3] != 0) {
	snprintf(buf, sizeof(buf) - 2, "/cpd <#>\n");
	PrintText(sess, buf);
	return(0);
    }

    i = atoi(word_eol[2]);
    snprintf(buf, sizeof(buf) - 2, "Setting DebugLevel: %d (%s)\n", i, word_eol[2]);
    PrintText(sess, buf);

    debug = i;

    return(0);
}


int cmd_hreq (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
    char buf[512];


    if (*word_eol[2] == 0 || *word_eol[3] != 0) {
	snprintf(buf, sizeof(buf) - 2, "/hreq <nick>\n");
	PrintText(sess, buf);
	return(0);
    }

    g_serv = sess->server;
    cp_HANDSHAKE_REQ(word_eol[2]);
    g_serv = NULL;

    return(0);
}


/* INIT/CLEANUP */
void hook_signal_after_te(struct xp_signal *sig)
{
    g_assert(sig);
    g_assert(sig->callback);

    sigroots[sig->signal] = g_slist_append(sigroots[sig->signal], sig);
}


int module_init(int ver, struct module *mod, struct session *sess)
{
    char buf[512];


    if (ver != MODULE_IFACE_VER)
	return(1);
    if (module_find(MODNAME)) {
	PrintText(sess, "%%C4" MODNAME "%%O already loaded...\n");
	return(1);
    }

    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O %%C4" MODNAME "%%O v%%B0.1a%%B, protocol version %%B0.1.1a%%B. Compiled for %%B[%%Bx%%B]%%Bchat "VERSION".\n");
    check_special_chars(buf);
    PrintText(sess, buf);

    mod->name = MODNAME;
    mod->desc = MODDESC;

    /* psybnc emulation */
    cp_adduser();

    user(usern)->encrypt = loadlist(KEYFILE, user(usern)->encrypt);

    sig[0].signal = XP_CHANMSG;
    sig[0].callback = XP_CALLBACK(chanmsg);
    sig[0].naddr = &chanmsg_next;
    sig[0].mod = mod;
    hook_signal(&sig[0]);

    sig[1].signal = XP_TE_UCHANMSG;
    sig[1].callback = XP_CALLBACK(te_uchanmsg_ate);
    sig[1].naddr = &te_uchanmsg_ate_next;
    sig[1].mod = mod;
    hook_signal_after_te(&sig[1]);

    sig[2].signal = XP_PRIVMSG;
    sig[2].callback = XP_CALLBACK(privmsg);
    sig[2].naddr = &privmsg_next;
    sig[2].mod = mod;
    hook_signal(&sig[2]);

    cp_cmd_set.mod = mod;
    cp_cmd_set.cmds = cp_cmds;
    module_add_cmds(&cp_cmd_set);

    return(0);
}


void module_cleanup(struct module *mod, struct session *sess)
{
    char buf[512];
    int i;


    snprintf(buf, sizeof(buf) - 2, "-%%C10-%%C11-%%O " MODNAME " %%Bkilled%%B... %%UTrust No One%%U... %%C15%%U[%%U%%ODaP%%C15%%U]%%U%%O\n");
    check_special_chars(buf);
    PrintText(sess, buf);

    /* psybnc emulation */
    cp_deluser();

    for (i = 0; i <= 2; i++)
	unhook_signal(&sig[i]);
}
