/*
    ICRYPT+ header
	        -- DaP <profeta@freemail.c3.hu>
*/

/*
    $Id: icrypt+.h,v 1.1 2000/04/16 16:25:36 dap Exp $
*/

/* +++ API +++ */
void xc_cp_noticeuser(char *from, char *msg);
#define	NOTICEUSER(a, b)	xc_cp_noticeuser(a, b);
void xc_cp_send(char *to, char *msg);
#define	SEND(a, b)		xc_cp_send(a, b);
#define	DEBUGLEVEL		debug
#define usern			0

/* misc */
// #define	NOTICE		":CRYPT+/dap!dap@burning.hell NOTICE %s :"

#define	RSA_KEYLEN	768
#define	TMOUT_REQ	180
#define	HANDSHAKE_REQ	"[N]!handshake_req!"
#define	HANDSHAKE_REP	"[N]!handshake_rep!"
#define	HANDSHAKE_KEY	"[N]!handshake_key!"
#define	HANDSHAKE_ACK	"[N]!handshake_ack!"

#define	NOENCRYPT	"[N]"
#define	BLOWFISHENCRYPT	"[B]"
#define	NOSIGN		"[NS]"
#define	BADSIGN		"[BS]"
#define	SIGN		"\x02""%.4x""\x02"
#define	ACTION		"\x01""ACTION"

struct stringarray {
    char *entry;
    struct stringarray *next;
};

struct encryptreq {
    char to[200];
    char pass[56];
    time_t reqtime;
    struct encryptreq *next;
};

struct usert {
    struct stringarray *encrypt;
    struct encryptreq *encryptreq;
};

/* crypt+ prototypes */
void cp_adduser();
void cp_deluser();
struct usert *user(int un);
void cp_HANDSHAKE_REQ(char *ircnick);
int cp_chk_HANDSHAKE_MSG(char *ircnick, char *irccontent);
void cp_chk_crypt(char *_mynick, char *_ircnick, char *_from, char *irccontent, int irccontent_len, char fromme);
int cp_isencrypted(char *passreq);

/* psybnc prototypes */
int ucase (char *inc);
char *getstring(int entry, struct stringarray *ltm);
struct stringarray *addstring(char *toadd, struct stringarray *ltm);
struct stringarray *removestring(int entry, struct stringarray *ltm);
struct stringarray *loadlist(char *afile,struct stringarray *th);
struct stringarray *writelist(char *host, char *param, char *afile,struct stringarray *th);
struct stringarray *eraselist(int entry, char *afile,struct stringarray *th);
char *hashstring(unsigned char *unhashed,unsigned size);
char *unhashstring(unsigned char *hashed);
char *BLOW_stringencrypt(unsigned char *input, unsigned char *key);
char *BLOW_stringdecrypt(unsigned char *input, unsigned char *key);

/* internal use for p_hash */
struct stringarray *first;
